'#######################################################################
' Mask Maker 1.0
' Copyright (c) Thunder software 2000-2001
'#######################################################################
DECLARE SUB loadbmp (Pic$, x%, y%, w%, h%)
DECLARE FUNCTION exist% (fichier$)
DECLARE SUB putx (x1%, y1%, x2%, y2%, coul%, coulr%)
DECLARE SUB GetPalette (Attr%, Red%, Green%, Blue%)
DECLARE SUB SetPalette (Attr%, Red%, Green%, Blue%)
DECLARE SUB getg (table%(), x1%, y1%, x2%, y2%)
DECLARE SUB putmask (table%(), x%, y%, xtable%, ytable%)
DEFINT A-Z

REM $DYNAMIC
DIM personage(0 TO 32006) AS INTEGER

ON ERROR GOTO erreur

SHELL "ts.exe"

copy$ = "Asher256 2000-2001"
xpos = 55
debut:
CLS

COLOR 15: LOCATE 25, xpos: PRINT copy$;
COLOR 7: LOCATE 1, 1
COLOR 7
COLOR 15
PRINT "                        Creation de masque pour sprites"
COLOR 7
FILES "*.BMP"
COLOR 7
PRINT

PRINT "Donnez Fichier ";
COLOR 15
PRINT ".BMP ";
COLOR 7
INPUT ""; perso$
IF perso$ = "" THEN CLS : END

IF exist(perso$) = 0 THEN
        PRINT "Le fichier n'existe pas..."
        END
END IF


PRINT "Donnez Fichier cible ";
COLOR 15
PRINT ".BSV ";
COLOR 7


INPUT ""; cible$

SCREEN 13

'-------------->>> load PERSONAGE
CLS
CALL loadbmp(perso$, 0, 0, x, y)

IF x > 320 THEN x = 320
IF y > 200 THEN y = 200

CALL getg(personage(), 0, 0, x - 1, y - 1)


'----------->>> load DECORE
CLS
CALL putx(0, 0, x - 1, y - 1, 0, 255)
CALL putmask(personage(), 0, 0, x, y)

LOCATE 15, 1: PRINT "Appuyez sur une touche...";


'-------------------BSAVE -------------------------------
DIM dessin(x * y)

GET (0, 0)-(x - 1, y - 1), dessin
'--------->>sauvegarde dans un fichier<<<------------------
DEF SEG = VARSEG(dessin(0))
BSAVE cible$, VARPTR(dessin(0)), (x * y) + 4
DEF SEG


CALL putx(0, 0, x - 1, y - 1, 255, 15)

SCREEN 0
WIDTH 80

PRINT "Fichier BMP: "; perso$
PRINT "Fichier BSV: "; cible$
PRINT "x: "; x
PRINT "y: "; y

a$ = INPUT$(1)

GOTO debut
erreur:
IF ERR = 53 THEN RESUME NEXT
PRINT "Erreur N "; ERR
END

REM $STATIC
FUNCTION exist (fichier$)

intnum = FREEFILE
OPEN fichier$ FOR BINARY AS intnum
IF LOF(intnum) = 0 THEN
        CLOSE intnum
        KILL fichier$
        exist = 0
        EXIT FUNCTION
END IF
exist = 1
CLOSE intnum

END FUNCTION

SUB getg (table(), x1, y1, x2, y2)

FOR py = y1 TO y2
FOR px = x1 TO x2
     d = d + 1
     table(d) = POINT(px, py)
NEXT
NEXT



END SUB

SUB GetPalette (Attr%, Red%, Green%, Blue%)

OUT &H3C7, Attr%
Red% = INP(&H3C9)
Green% = INP(&H3C9)
Blue% = INP(&H3C9)

END SUB

'-------------------------------------------------------------------
'DRAWBMP8.BAS
'-------------------------------------------------------------------
'Stephen L. Maxson
'smax@isc-durant.com
'-------------------------------------------------------------------
'This is the fastest 8-bit .BMP loader I've come up with so far.
'Uses Coridon Henshaw's "SetPalette" SUBroutine to speed up color
'loading; If you want to use DrawBMP8 in another program, SetPalette
'will have to go with it.  DrawBMP8 reads from the file into a
'buffer of up to 32767 bytes, then decodes to screen from there,
'which is much faster then reading and decoding one byte at a time.
'Qbasic seems to have a problem with strings of that length; I would
'suggest setting BufferMax% to 19000 or so to take care of this.
'-------------------------------------------------------------------
'To display an 8-bit .BMP file, just call the SUB, passing the name
'and the X and Y coordinates to start at.
'EXAMPLES:
'DrawBMP8 "funky.bmp", 0, 0
'File$ = "groovy.bmp": DrawBMP8 File$, 96, 32
'-------------------------------------------------------------------
'The SUB takes for granted that you are in screen mode 13 (MCGA/VGA
'320x200x256), and that you are passing it the name of a valid 8-bit
'.BMP file.  It also will not clear the screen for you.  If the .BMP
'image is larger than 320x200 (- X and Y), only the upper-left-hand
'portion of the image will be displayed.
'-------------------------------------------------------------------
'Public Domain, (ab)use at your own risk.
'-------------------------------------------------------------------
'
'
SUB loadbmp (Pic$, x%, y%, w, h)

'Maximum size of buffer, change to 19000 for QBasic-
BufferMax% = 32767
OPEN Pic$ FOR BINARY AS #1
'Read width and height of image-
GET #1, 19, BMPWidth%
GET #1, 23, BMPHeight%
w = BMPWidth%
h = BMPHeight%

'Each raster must be a multiple of 4 bytes, this next line takes
'care of 'padded' bytes at the end of rasters of odd-width images-
IF BMPWidth% / 4 <> BMPWidth% \ 4 THEN PadBytes% = 4 - (BMPWidth% MOD 4)
'Read the entire palette into a buffer-
a$ = SPACE$(1024)
GET #1, 55, a$
'Decode the palette from the buffer-
FOR I% = 0 TO 255
  Blue% = ASC(MID$(a$, I% * 4 + 1, 1)) \ 4
  Green% = ASC(MID$(a$, I% * 4 + 2, 1)) \ 4
  Red% = ASC(MID$(a$, I% * 4 + 3, 1)) \ 4
  'Henshaw's routine for faster palette setting
  SetPalette I%, Red%, Green%, Blue%
NEXT I%
n& = 1079
a% = BufferMax%
a% = a% - (BufferMax% MOD (BMPWidth% + PadBytes%)) 'Find usable buffer size-
B% = a% \ (BMPWidth% + PadBytes%) - 1              'Find rasters per buffer-
a$ = SPACE$(a%)
k% = BMPHeight% - 1
'If current buffer is off screen, read another-
DO WHILE k% - B% > (199 - y%)
  'Read a buffer's worth-
  GET #1, n&, a$
  'Move file pointer forward by buffer size-
  n& = n& + a%
  'Decrease image line counter
  k% = k% - B%
LOOP
DO
  'Read a buffer's worth-
  GET #1, n&, a$
  '(B% + 1) worth of rasters in buffer-
  FOR I% = 0 TO B%
    'BMPWidth% = pixels per raster-
    FOR J% = 0 TO (BMPWidth% - 1)
      'Decode each pixel from buffer-
      c% = ASC(MID$(a$, I% * (BMPWidth% + PadBytes%) + J% + 1, 1))
      'If pixel falls in viewing area, plot it-
      IF J% < (320 - x%) AND k% < (200 - y%) THEN PSET (J% + x%, k% + y%), c%
    NEXT J%
    'Done with this raster line, on to the next-
    k% = k% - 1
    'K% < 0 condition must be checked, in case data at end of file
    'does not completely fill the final buffer read-
    IF k% < 0 THEN EXIT FOR
  NEXT I%
  'Move file pointer forward by buffer size-
  n& = n& + a%
'If K% is not < 0, there's more image-
LOOP UNTIL k% < 0
'Put a fork in it, it's done-
CLOSE #1

END SUB

SUB putmask (table(), x, y, xtable, ytable)

nx = x
ny = y

'LOCATE 25, 1: PRINT "XTABLE:"; xtable; "YTABLE"; ytable; ""
FOR py = y TO y + ytable - 1
FOR px = x TO x + xtable - 1

d = d + 1
IF table(d) <> 0 THEN PSET (px, py), 0


nx = nx + 1


NEXT
ny = ny + 1
NEXT

END SUB

SUB putx (x1, y1, x2, y2, coul, coulr)

'coul c'est la couleur qu'ib  doit remplacer
'coulr c'est- la couleur qui va remplacer coul


FOR y = y1 TO y2
FOR x = x1 TO x2
T = POINT(x, y)
IF T = coul THEN PSET (x, y), coulr
NEXT
NEXT


END SUB

SUB SaveBMP (Pic$, x1%, y1%, x2%, y2%)

'Calculate width and height of image-
BMPWidth% = x2% - x1% + 1
BMPHeight% = y2% - y1% + 1
'Each raster must be a multiple of 4 bytes, this next line takes
'care of 'padded' bytes at the end of rasters of odd-width images-
IF BMPWidth% / 4 <> BMPWidth% \ 4 THEN PadBytes% = 4 - (BMPWidth% MOD 4)
OPEN Pic$ FOR BINARY AS #1
'General Picture Information-
'  BMP format marker-
Buffer$ = "BM"
'  File size minus header-
L& = (BMPWidth% + PadBytes%) * BMPHeight% + 1078
Buffer$ = Buffer$ + MKL$(L&)
'  Reserved 1-
Buffer$ = Buffer$ + CHR$(0) + CHR$(0)
'  Reserved 2-
Buffer$ = Buffer$ + CHR$(0) + CHR$(0)
'  Number of bytes offset to picture data-
Buffer$ = Buffer$ + MKL$(1078)
'Information Header-
'  Size of information header-
Buffer$ = Buffer$ + MKL$(40)
'  Picture width in pixels-
L& = BMPWidth%
Buffer$ = Buffer$ + MKL$(L&)
'  Picture height in pixels-
L& = BMPHeight%
Buffer$ = Buffer$ + MKL$(L&)
'  Number of planes-
Buffer$ = Buffer$ + CHR$(1) + CHR$(0)
'  Bits per pixel-
Buffer$ = Buffer$ + CHR$(8) + CHR$(0)
'  Compression-
Buffer$ = Buffer$ + MKL$(0)
'  Image size in bytes-
L& = (BMPWidth% + PadBytes%) * BMPHeight%
Buffer$ = Buffer$ + MKL$(L&)
'  Picture width in pixels per meter-
Buffer$ = Buffer$ + MKL$(0)
'  Picture height in pixels per meter-
Buffer$ = Buffer$ + MKL$(0)
'  Colors used in picture-
Buffer$ = Buffer$ + MKL$(256)
'  Number of important colors-
Buffer$ = Buffer$ + MKL$(256)
PUT #1, 1, Buffer$
'Save palette data-
Buffer$ = ""
FOR I% = 0 TO 255
  GetPalette I%, Red%, Green%, Blue%
  'Palette is saved B, G, R with unused byte trailing-
  Buffer$ = Buffer$ + CHR$(Blue% * 4)
  Buffer$ = Buffer$ + CHR$(Green% * 4)
  Buffer$ = Buffer$ + CHR$(Red% * 4)
  Buffer$ = Buffer$ + CHR$(0)
NEXT I%
PUT #1, , Buffer$
'Save image data-
FOR I% = (BMPHeight% - 1) TO 0 STEP -1
  Buffer$ = ""
  FOR J% = 0 TO (BMPWidth% - 1)
    Buffer$ = Buffer$ + CHR$(POINT(x1% + J%, y1% + I%))
  NEXT J%
  IF PadBytes% > 0 THEN
    FOR J% = 1 TO PadBytes%
      Buffer$ = Buffer$ + CHR$(0)
    NEXT J%
  END IF
  PUT #1, , Buffer$
NEXT I%
'Put a fork in it, it's done-
CLOSE #1

END SUB

SUB SetPalette (Attr%, Red%, Green%, Blue%)

OUT &H3C7, Attr%
OUT &H3C8, Attr%
OUT &H3C9, Red%
OUT &H3C9, Green%
OUT &H3C9, Blue%

END SUB

